package com.inca.npbusi.saset.bms_sa_rec_offset;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.control.UserManager;
import com.inca.np.util.SendHelper;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.Entrychose;
import java.util.Vector;
import javax.swing.JOptionPane;

public class BmsSaRecOffset_ste extends CSteModelAp {
   private String a = UserManager.getCurrentUser().getEntryid();
   private String b = UserManager.getCurrentUser().getEntryname();

   public String getEntryid() {
      return this.a;
   }

   public void setEntryid(String var1) {
      this.a = var1;
   }

   public String getEntryName() {
      return this.b;
   }

   public void setEntryName(String var1) {
      this.b = var1;
   }

   public BmsSaRecOffset_ste(CFrame var1) {
      super(var1, "销售结算收款单");
   }

   public String getTablename() {
      return "bms_sa_rec_offset_v";
   }

   public String getSaveCommandString() {
      return "com.inca.npbusi.saset.bms_sa_rec_offset.BmsSaRecOffset_ste.销售收款冲调";
   }

   protected int on_actionPerformed(String var1) {
      this.commitEdit();
      if ("销售收款单冲调".equals(var1)) {
         int[] var2;
         if ((var2 = this.getTable().getSelectedRows()).length == 0) {
            this.infoMessage("提示", "请选择需要进行销售收款冲调的单据");
         }

         for(int var3 = 0; var3 < var2.length; ++var3) {
            if ("".equals(this.getItemValue(var2[var3], "certid"))) {
               this.infoMessage("提醒", "细单没有生成传票，不需要在此冲调。回退后修改或者作废即可");
               return -1;
            }

            if ("1".equals(this.getItemValue(var2[var3], "correctflag"))) {
               this.infoMessage("提醒", "该单据已经进行过冲调！");
               return -1;
            }

            if ("2".equals(this.getItemValue(var2[var3], "correctflag"))) {
               this.infoMessage("提醒", "该单据是冲单，不能进行冲调！");
               return -1;
            }
         }

         BmsSaRecOffset_ste var16 = this;
         Vector var17 = new Vector();
         DBColumnDisplayInfo var4 = new DBColumnDisplayInfo("saRecID", "number");
         var17.add(var4);
         var4 = new DBColumnDisplayInfo("saRecDtlID", "number");
         var17.add(var4);
         var4 = new DBColumnDisplayInfo("saSettleDtlID", "number");
         var17.add(var4);
         var4 = new DBColumnDisplayInfo("total_line", "number");
         var17.add(var4);
         DBTableModel var18 = new DBTableModel(var17);
         int[] var19 = this.getTable().getSelectedRows();
         int var5 = 0;

         label91:
         while(true) {
            if (var5 >= var19.length) {
               StringCommand var20 = new StringCommand("销售收款冲调管理.销售收款红冲");
               DataCommand var21;
               (var21 = new DataCommand()).setDbmodel(var18);
               ClientRequest var22;
               (var22 = new ClientRequest()).addCommand(var20);
               var22.addCommand(var21);
               Object var23 = null;

               try {
                  StringCommand var11;
                  if ((var11 = (StringCommand)SendHelper.sendRequest(var22).commandAt(0)).getString().startsWith("+OK")) {
                     var16.infoMessage("提示", "销售收款冲调完成！~");
                     int var24 = 0;

                     while(true) {
                        if (var24 >= var19.length) {
                           break label91;
                        }

                        var16.tableChanged();
                        var16.setdbStatus(var19[var24], 0);
                        var16.doRequery();
                        ++var24;
                     }
                  } else {
                     var16.infoMessage("提示", var11.getString());
                  }
               } catch (Exception var14) {
                  var14.printStackTrace();
                  var16.infoMessage("提示", "销售收款冲调失败:" + var14.getMessage());
               }
               break;
            }

            int var6 = var18.getRowCount();
            String var7 = JOptionPane.showInputDialog(var16.frame, "请输入冲调金额！", var16.getItemValue(var19[var5], "total_line"));
            if (var7 == null) {
               break;
            }

            try {
               double var10;
               if ((var10 = Double.parseDouble(var7)) <= 0.0) {
                  var16.frame.infoMessage("提示", "冲调金额必须大于零！");
                  break;
               }

               double var12 = Double.parseDouble(var16.getItemValue(var19[var5], "total_line"));
               if (Math.abs(var10) > Math.abs(var12)) {
                  if (var12 >= 0.0) {
                     var16.frame.infoMessage("提示", "冲调金额必须小于细单收款金额！");
                     break;
                  }

                  if (var12 < 0.0) {
                     var16.frame.infoMessage("提示", "冲调金额必须大于细单收款金额！");
                     break;
                  }
               }
            } catch (Exception var15) {
               var16.frame.infoMessage("提示", "冲调金额必须为数字！");
               break;
            }

            var18.appendRow();
            var18.setItemValue(var6, "saRecID", var16.getItemValue(var19[var5], "sarecid"));
            var18.setItemValue(var6, "saRecDtlID", var16.getItemValue(var19[var5], "sarecdtlid"));
            var18.setItemValue(var6, "saSettleDtlID", var16.getItemValue(var19[var5], "sasettledtlid"));
            var18.setItemValue(var6, "total_line", var7);
            ++var5;
         }
      }

      if (var1.equals("切换独立单元")) {
         if (this.getModifiedDbmodel().getRowCount() > 0) {
            this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
            return -1;
         } else {
            if (Entrychose.setUserEntryInfo(this.frame)) {
               this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
               this.setEntryName(ClientUserManager.getCurrentUser().getEntryname());
               this.doRetrieve("1=2");
            }

            return 0;
         }
      } else {
         return super.on_actionPerformed(var1);
      }
   }

   protected String getOtherWheres() {
      String var1;
      if ((var1 = this.getEntryid()) != null && var1.length() != 0) {
         var1 = "entryid = " + var1 + " and useStatus = 1";
         return var1 + super.getOtherWheres();
      } else {
         this.infoMessage("提示", "您当前登录的角色没有指定独立单元，不能操作！");
         return null;
      }
   }
}
